/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.company.catweb.ejb;

import com.company.catweb.model.*;
import java.util.List;
import javax.ejb.Local;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

/**
 *
 * @author Wim
 */
@Local
public interface CatWebSessionLocal {
    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean createCatalog(Catalog c);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean createCategory(Category c);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean createProduct(Product c);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean deleteCatalog(int id);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean deleteCategory(int id);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean deleteProduct(int id);

    List findCatalogs(String n);

    List findCategories(String n);

    List findProducts(String n);

    Catalog readCatalog(int id);

    Category readCategory(int id);

    Product readProduct(int id);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean updateCatalog(Catalog c) throws Exception;

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean updateCategory(Category c);

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    boolean updateProduct(Product c);
}
